//mf_rememberhats by Arg!

#pragma semicolon 1

#include <sourcemod>
#undef REQUIRE_PLUGIN
#include <modelfun>
#define VERSION "0.9"

/*****************************************************************


			P L U G I N   I N F O


*****************************************************************/
public Plugin:myinfo =
{
	name = "ModelFun.RememberHats",
	author = "Arg!",
	description = "Example of ModelFun includes - saves hat info against steam ID applies at spawn",
	version = VERSION,
	url = "N/A"
};

/*****************************************************************


			G L O B A L   V A R S


*****************************************************************/
new Handle:hKVRememberHats = INVALID_HANDLE;
new String:g_fileset[128];


/*****************************************************************


			F O R W A R D   P U B L I C S


*****************************************************************/
public OnPluginStart()
{
	//prepare kv hat file
	hKVRememberHats=CreateKeyValues("ModelFun_RememberHats");
	
  	BuildPath(Path_SM, g_fileset, 128, "data/modelfun_rememberhats.txt");
	if(!FileToKeyValues(hKVRememberHats, g_fileset))
	{
		KeyValuesToFile(hKVRememberHats, g_fileset);
	}
	
	RegAdminCmd("sm_permhat", Command_PermHat, ADMFLAG_ROOT, "sm_permhat <name or #userid> <modelname> - sets a hat for player to recieve every time they join the server");
	RegAdminCmd("sm_permhatoff", Command_PermHatOff, ADMFLAG_ROOT, "sm_permhatoff <name or #userid> - removes persistent hat from player");
	
}

public OnClientPostAdminCheck(client )
{
	new String:steamId[32];
	new String:modelname[129];
	
	if( GetClientAuthString(client, steamId, sizeof(steamId)) ) 
	{	
		//get from kv file
		KvRewind(hKVRememberHats);
		if(KvJumpToKey(hKVRememberHats, steamId))
		{
			//Get hat model
			KvGetString(hKVRememberHats, "modelname", modelname, sizeof(modelname), "");
			
			if( strlen(modelname) > 0)
			{
				//hat client
				ModelFun_PerformHat(client, client, 1, modelname);
			}
		} 
		
		KvRewind(hKVRememberHats);
	}
}

public OnPluginEnd()
{		
	CloseHandle(hKVRememberHats);
}


/****************************************************************


			C A L L B A C K   F U N C T I O N S


****************************************************************/
public Action:Command_PermHat(client, args)
{
	decl String:target[65];
	decl String:modelname[129];
	
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS];
	decl target_count;
	decl bool:tn_is_ml;
	new String:steamId[32];
	
	//not enough arguments, display usage
	if (args < 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_permhat <name or #userid> <modelname>");
		return Plugin_Handled;
	}	

	//get command arguments
	GetCmdArg(1, target, sizeof(target));
	GetCmdArg(2, modelname, sizeof(modelname));

	//get the target of this command, return error if invalid
	if ((target_count = ProcessTargetString(
			target,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_NO_MULTI,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}	

	//set permanent hat in kv file	
	if( target_count > 0 && GetClientAuthString(target_list[0], steamId, sizeof(steamId)) )
	{
		DoPermHat(steamId,modelname,target_name,client);
		
		//hat client
		ModelFun_PerformHat(client, target_list[0], 1, modelname, false);
	}
	else
	{
		ReplyToCommand(client, "[SM] Unable to find player's steam id");
	}

	return Plugin_Handled;
}



public Action:Command_PermHatOff(client, args)
{
	decl String:target[65];
	
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS];
	decl target_count;
	decl bool:tn_is_ml;
	new String:steamId[32];
	
	//not enough arguments, display usage
	if (args < 1)
	{
		ReplyToCommand(client, "[SM] Usage: sm_permhatoff <name or #userid>");
		return Plugin_Handled;
	}	

	//get command arguments
	GetCmdArg(1, target, sizeof(target));

	//get the target of this command, return error if invalid
	if ((target_count = ProcessTargetString(
			target,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_NO_MULTI,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}	

	//set permanent hat in kv file	
	if( target_count > 0 && GetClientAuthString(target_list[0], steamId, sizeof(steamId)) )
	{
		DoPermHatOff(steamId,target_name,client);
		
		//unhat client
		ModelFun_HatOff(client, target_list[0]);
	}
	else
	{
		ReplyToCommand(client, "[SM] Unable to find player's steam id");
	}

	return Plugin_Handled;
}


/*****************************************************************


			P L U G I N   F U N C T I O N S


*****************************************************************/
DoPermHat( String:steamId[], String:modelname[], String:target_name[], client )
{
	KvJumpToKey(hKVRememberHats, steamId, true);
	KvSetString(hKVRememberHats, "modelname", modelname );

	KvRewind(hKVRememberHats);			
	KeyValuesToFile(hKVRememberHats, g_fileset);
	
	LogMessage( "\"%L\" set permanent hat for player \"%s\" (Steam ID: %s) to the model \"%s\"", client, target_name, steamId, modelname );
	ReplyToCommand(client, "[SM] Set permanent hat for player %s (Steam ID: %s) to the model \"%s\"", target_name, steamId, modelname);
}

DoPermHatOff( String:steamId[], String:target_name[], client )
{
	KvJumpToKey(hKVRememberHats, steamId);
	KvDeleteThis(hKVRememberHats);

	KvRewind(hKVRememberHats);			
	KeyValuesToFile(hKVRememberHats, g_fileset);
	
	LogMessage( "\"%L\" removed permanent hat for player \"%s\" (Steam ID: %s)", client, target_name, steamId );
	ReplyToCommand(client, "[SM] removed permanent hat for player %s (Steam ID: %s) ", target_name, steamId);
}