//mf_rememberphats by Arg!

#pragma semicolon 1

#include <sourcemod>
#undef REQUIRE_PLUGIN
#include <modelfun>
#define VERSION "0.9"

/*****************************************************************


			P L U G I N   I N F O


*****************************************************************/
public Plugin:myinfo =
{
	name = "ModelFun.RememberPHats",
	author = "Arg!",
	description = "Example of ModelFun includes - saves particle hat info against steam ID applies at spawn",
	version = VERSION,
	url = "N/A"
};

/*****************************************************************


			G L O B A L   V A R S


*****************************************************************/
new Handle:hKVRememberPHats = INVALID_HANDLE;
new String:g_fileset[128];


/*****************************************************************


			F O R W A R D   P U B L I C S


*****************************************************************/
public OnPluginStart()
{
	//prepare kv hat file
	hKVRememberPHats=CreateKeyValues("ModelFun_RememberPHats");
	
  	BuildPath(Path_SM, g_fileset, 128, "data/modelfun_rememberphats.txt");
	if(!FileToKeyValues(hKVRememberPHats, g_fileset))
	{
		KeyValuesToFile(hKVRememberPHats, g_fileset);
	}
	
	RegAdminCmd("sm_permphat", Command_PermPHat, ADMFLAG_ROOT, "sm_permphat <name or #userid> <particlename> - sets a particle hat for player to recieve every time they join the server");
	RegAdminCmd("sm_permphatoff", Command_PermPHatOff, ADMFLAG_ROOT, "sm_permphatoff <name or #userid> - removes persistent particle hat from player");
	
}

public OnClientPostAdminCheck(client )
{
	new String:steamId[32];
	new String:particlename[129];
	
	if( GetClientAuthString(client, steamId, sizeof(steamId)) ) 
	{	
		//get from kv file
		KvRewind(hKVRememberPHats);
		if(KvJumpToKey(hKVRememberPHats, steamId))
		{
			//Get hat particle
			KvGetString(hKVRememberPHats, "particlename", particlename, sizeof(particlename), "");
			
			if( strlen(particlename) > 0)
			{
				//hat client
				ModelFun_PerformPHat(client, client, 1, particlename);
			}
		} 
		
		KvRewind(hKVRememberPHats);
	}
}

public OnPluginEnd()
{		
	CloseHandle(hKVRememberPHats);
}


/****************************************************************


			C A L L B A C K   F U N C T I O N S


****************************************************************/
public Action:Command_PermPHat(client, args)
{
	decl String:target[65];
	decl String:particlename[129];
	
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS];
	decl target_count;
	decl bool:tn_is_ml;
	new String:steamId[32];
	
	//not enough arguments, display usage
	if (args < 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_permphat <name or #userid> <particlename>");
		return Plugin_Handled;
	}	

	//get command arguments
	GetCmdArg(1, target, sizeof(target));
	GetCmdArg(2, particlename, sizeof(particlename));

	//get the target of this command, return error if invalid
	if ((target_count = ProcessTargetString(
			target,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_NO_MULTI,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}	

	//set permanent hat in kv file	
	if( target_count > 0 && GetClientAuthString(target_list[0], steamId, sizeof(steamId)) )
	{
		DoPermPHat(steamId,particlename,target_name,client);
		
		//hat client
		ModelFun_PerformPHat(client, target_list[0], 1, particlename, false);
	}
	else
	{
		ReplyToCommand(client, "[SM] Unable to find player's steam id");
	}

	return Plugin_Handled;
}



public Action:Command_PermPHatOff(client, args)
{
	decl String:target[65];
	
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS];
	decl target_count;
	decl bool:tn_is_ml;
	new String:steamId[32];
	
	//not enough arguments, display usage
	if (args < 1)
	{
		ReplyToCommand(client, "[SM] Usage: sm_permphatoff <name or #userid>");
		return Plugin_Handled;
	}	

	//get command arguments
	GetCmdArg(1, target, sizeof(target));

	//get the target of this command, return error if invalid
	if ((target_count = ProcessTargetString(
			target,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_NO_MULTI,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}	

	//set permanent hat in kv file	
	if( target_count > 0 && GetClientAuthString(target_list[0], steamId, sizeof(steamId)) )
	{
		DoPermPHatOff(steamId,target_name,client);
		
		//unhat client
		ModelFun_PHatOff(client, target_list[0]);
	}
	else
	{
		ReplyToCommand(client, "[SM] Unable to find player's steam id");
	}

	return Plugin_Handled;
}


/*****************************************************************


			P L U G I N   F U N C T I O N S


*****************************************************************/
DoPermPHat( String:steamId[], String:particlename[], String:target_name[], client )
{
	KvJumpToKey(hKVRememberPHats, steamId, true);
	KvSetString(hKVRememberPHats, "particlename", particlename );

	KvRewind(hKVRememberPHats);			
	KeyValuesToFile(hKVRememberPHats, g_fileset);
	
	LogMessage( "\"%L\" set permanent particle hat for player \"%s\" (Steam ID: %s) to the particle \"%s\"", client, target_name, steamId, particlename );
	ReplyToCommand(client, "[SM] Set permanent particle hat for player %s (Steam ID: %s) to the particle \"%s\"", target_name, steamId, particlename);
}

DoPermPHatOff( String:steamId[], String:target_name[], client )
{
	KvJumpToKey(hKVRememberPHats, steamId);
	KvDeleteThis(hKVRememberPHats);

	KvRewind(hKVRememberPHats);			
	KeyValuesToFile(hKVRememberPHats, g_fileset);
	
	LogMessage( "\"%L\" removed permanent particle hat for player \"%s\" (Steam ID: %s)", client, target_name, steamId );
	ReplyToCommand(client, "[SM] removed permanent particle hat for player %s (Steam ID: %s) ", target_name, steamId);
}