/*****************************************************************


			G L O B A L   V A R S


*****************************************************************/
new g_HatTarget[MAXPLAYERS+1];
new bool:g_Hatted[MAXPLAYERS+1] = {false, ...};
new String:g_Hatmodel[MAXPLAYERS+1][129];
new g_HatEntity[MAXPLAYERS+1];


/*****************************************************************


			F O R W A R D   P U B L I C S


*****************************************************************/

OnPluginStart_Hat()
{
	RegAdminCmd("sm_hat", Command_Hat, ADMFLAG_ROOT,"sm_hat <name or #userid> <modelname> [1|0] - toggles or sets player's hat status");
}

OnMapEnd_Hat()
{
	new maxclients = GetMaxClients();
	for (new i = 0; i <= maxclients; i++)
	{
		g_Hatted[i] = false;
	}
}

bool:OnClientConnect_Hat(client)
{
	KillHat(client);
	return true;
}

bool:AskPluginLoad_Hat()
{
	CreateNative("ModelFun_HatOff", Native_HatOff);
	CreateNative("ModelFun_PerformHat", Native_PerformHat);
	
	return true;
}

/****************************************************************


			C A L L B A C K   F U N C T I O N S


****************************************************************/
Event_PlayerSpawn_Hat(Handle:event) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	CreateTimer(0.1, Timer_Event_PlayerSpawn_Hat, client);
}

Event_PlayerDeath_Hat(Handle:event) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	CreateTimer(0.1, Timer_Event_PlayerDeath_Hat, client);
}

Event_PlayerTeam_Hat(Handle:event) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	CreateTimer(0.1, Timer_Event_PlayerTeam_Hat, client);
}


public Action:Timer_Event_PlayerSpawn_Hat(Handle:timer, any:client) 
{
	if( client && IsClientConnected(client) && !IsFakeClient(client) )
	{	
		if (g_Hatted[client] == true)
		{
			KillHat(client);
			CreateHat(client);
		}
	}
	
	return Plugin_Handled;
}

public Action:Timer_Event_PlayerDeath_Hat(Handle:timer, any:client) 
{
	if( client && IsClientConnected(client) && !IsFakeClient(client) )
	{	
		if (g_Hatted[client] == true)
		{
			KillHat(client);
			g_Hatted[client] = true;
		}
	}
	
	return Plugin_Handled;
}

public Action:Timer_Event_PlayerTeam_Hat(Handle:timer, any:client) 
{
	if( client && IsClientConnected(client) && !IsFakeClient(client) )
	{	
		if (g_Hatted[client] == true)
		{
			KillHat(client);
			g_Hatted[client] = true;
		}
	}
	
	return Plugin_Handled;
}


public Action:Command_Hat(client, args)
{
	decl String:model[129];
	decl String:target[65];
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS];
	decl target_count;
	decl bool:tn_is_ml;
	new toggle = 2;
	
	if (args < 2 )
	{
		ReplyToCommand(client, "[SM] Usage: sm_hat <#userid|name> <modelname> [1|0]");
		return Plugin_Handled;
	}
		
	GetCmdArg(1, target, sizeof(target));	
	GetCmdArg(2, model, sizeof(model));
	if (args > 2)
	{
		decl String:arg3[2];
		GetCmdArg(3, arg3, sizeof(arg3));
		if (StrEqual(arg3[0],"1"))
		{
			toggle = 1;
		}
		else if (StrEqual(arg3[0],"0"))
		{
			toggle = 0;
		}
	}
	
	if ((target_count = ProcessTargetString(
			target,
			client,
			target_list,
			MAXPLAYERS,
			0,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}
	
	for (new i = 0; i < target_count; i++)
	{
		SetHatModel(target_list[i], model);
		PerformHat(client, target_list[i], toggle);
	}
	
	ShowActivity2(client, "[SM] ", "Toggled hat \"%s\" on target '%s'", model, target_name);
	
	return Plugin_Handled; 
}


/*****************************************************************


			N A T I V E   F U N C T I O N S


*****************************************************************/
public Native_PerformHat(Handle:plugin, numParams)
{
	decl client;
	decl target;
	decl toggle;
	decl String:model[129];
	new bool:hatnow= true;
	
	client = GetNativeCell(1);
	target = GetNativeCell(2);
	toggle = GetNativeCell(3);
	GetNativeString(4, model, sizeof(model));
	
	if( numParams > 5 )
	{
		hatnow = GetNativeCell(5);
	}

	SetHatModel( target, model );
	
	if( hatnow )
	{
		return PerformHat( client, target, toggle );
	}
	
	return true;
}

public Native_HatOff(Handle:plugin, numParams)
{
	decl client;
	decl target;
	
	client = GetNativeCell(1);
	target = GetNativeCell(2);
	
	PerformHat( client, target, 0 );
}

/*****************************************************************


			P L U G I N   F U N C T I O N S


*****************************************************************/
SetHatModel(target, String:model[129])
{	
	g_Hatmodel[target] = model;
}

bool:PerformHat(client, target, toggle)
{
	switch (toggle)
	{
		case (2):
		{
			if (g_Hatted[target] == false)
			{
				CreateHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" hatted with model \"%s\"", client, target, g_Hatmodel[target]);
				return true;
			}
			else
			{
				KillHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" normal", client, target);
				return false;
			}
		}

		case (1):
		{
			if (g_Hatted[target] == false)
			{
				CreateHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" hatted with model \"%s\"", client, target, g_Hatmodel[target]);
				return true;
			}			
		}
		
		case (0):
		{
			if (g_Hatted[target] == true)
			{
				KillHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" normal", client, target);
				return false;
			}				
		}
	}
	return false;
}

KillHat(target)
{
	if (g_Hatted[target] == true)
	{
		g_Hatted[target] = false;
		if (IsValidEntity(g_HatEntity[target]))
		{
			RemoveEdict(g_HatEntity[target]);
			g_HatEntity[target] = -1;
		}
	}
}

CreateHat(target)
{
	g_Hatted[target] = true;
	new Float:fPosition[3];
	GetClientEyePosition(target, fPosition);
	new iModel;
	
	if( g_GameType == GAME_CSS || g_GameType == GAME_OTHER )
	{
		fPosition[2] += 15;
	}

	if (!IsModelPrecached(g_Hatmodel[target]))
	{
        PrecacheModel(g_Hatmodel[target]);
	}
	
	//check for voogru attachable extension - http://forums.alliedmods.net/showthread.php?t=126577
	if ( LibraryExists("Attachables") )
	{
		new Float:playerPos[3];
		new Float:hatLocation[3];
		
		//voogru lib call, attaches to player
		iModel = Attachable_CreateAttachable(target);
		
		//remove bonemerge flag to allow moving of entity
		SetEntProp(iModel, Prop_Data, "m_fEffects", GetEntProp(iModel, Prop_Data, "m_fEffects") & ~EF_BONEMERGE);  

		//get hat start location
		GetEntPropVector(iModel, Prop_Send, "m_vecOrigin", hatLocation);

		//get player location in world
		GetEntPropVector(target, Prop_Send, "m_vecOrigin", playerPos);

		//move hat up to above head, relative to players eyelevel
		hatLocation[2] += fPosition[2] - playerPos[2] +2;

		//move hat forward on player a bit
		hatLocation[0] += 8;

		//move the entity to around about players head
		TeleportEntity(iModel,hatLocation, NULL_VECTOR, NULL_VECTOR);

		//makes hat 'stick' with player in a realistic way
		SetVariantString("partyhat");
		AcceptEntityInput(iModel, "SetParentAttachmentMaintainOffset", iModel, iModel, 0);
		
		//set the model to the entity
		SetEntityModel(iModel, g_Hatmodel[target]);
		
	}
	else
	{
		
		iModel = CreateEntityByName("prop_dynamic_override");
		if (IsValidEntity(iModel))
		{			
			TeleportEntity(iModel,fPosition, NULL_VECTOR, NULL_VECTOR);
			SetVariantString("!activator");
			AcceptEntityInput(iModel, "SetParent", target, iModel, 0);
			SetVariantString("partyhat");
			AcceptEntityInput(iModel, "SetParentAttachmentMaintainOffset", iModel, iModel, 0);
			DispatchKeyValue(iModel, "model", g_Hatmodel[target]);
			DispatchKeyValue(iModel, "solid", "0");
			DispatchSpawn(iModel);
			AcceptEntityInput(iModel, "TurnOn", target, target, 0);
		}
	}
	
	g_HatEntity[target] = iModel;
	

}


/*****************************************************************


			A D M I N   M E N U   F U N C T I O N S


*****************************************************************/

SetupAdminMenu_Hat(TopMenuObject:parentmenu)
{
	AddToTopMenu(hTopMenu, 
		"sm_hat",
		TopMenuObject_Item,
		AdminMenu_Hat,
		parentmenu,
		"sm_hat",
		ADMFLAG_ROOT);
}

public AdminMenu_Hat(Handle:topmenu, 
					  TopMenuAction:action,
					  TopMenuObject:object_id,
					  param,
					  String:buffer[],
					  maxlength)
{
	if (action == TopMenuAction_DisplayOption)
	{
		Format(buffer, maxlength, "%s", "Hat player");
	}
	else if (action == TopMenuAction_SelectOption)
	{
		DisplayMenu_Hat_Player(param);
	}
}

DisplayMenu_Hat_Player(client)
{
	new Handle:menu = CreateMenu(MenuHandler_Hat_Player);
	
	decl String:title[100];
	Format(title, sizeof(title), "%s:", "Hat player");
	SetMenuTitle(menu, title);
	SetMenuExitBackButton(menu, true);
	
	AddTargetsToMenu(menu, client, true, false);
	
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Hat_Player(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];
		new userid, target;
		
		GetMenuItem(menu, param2, info, sizeof(info));
		userid = StringToInt(info);

		if ((target = GetClientOfUserId(userid)) == 0)
		{
			PrintToChat(param1, "[SM] %t", "Player no longer available");
		}
		else if (!CanUserTarget(param1, target))
		{
			PrintToChat(param1, "[SM] %t", "Unable to target");
		}
		else
		{
			g_HatTarget[param1] = userid;
			DisplayMenu_Hat_Model(param1);
			return;	// Return, because we went to a new menu and don't want the re-draw to occur.
		}
		
		/* Re-draw the menu if they're still valid */
		if (IsClientInGame(param1) && !IsClientInKickQueue(param1))
		{
			DisplayMenu_Hat_Player(param1);
		}
	}
	
	return;
}

DisplayMenu_Hat_Model(client)
{
	new Handle:menu = CreateMenu(MenuHandler_Hat_Model);
	
	decl String:title[100];
	Format(title, sizeof(title), "%s:", "Set Hat Model");
	SetMenuTitle(menu, title);
	SetMenuExitBackButton(menu, true);
	
	AddModelsToMenu(menu, "modellist");
	
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}


public MenuHandler_Hat_Model(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		new target;
		decl String:modelName[129];
		
		GetMenuItem(menu, param2, modelName, sizeof(modelName));
		
		if ((target = GetClientOfUserId(g_HatTarget[param1])) == 0)
		{
			PrintToChat(param1, "[SM] %t", "Player no longer available");
		}
		else if (!CanUserTarget(param1, target))
		{
			PrintToChat(param1, "[SM] %t", "Unable to target");
		}
		else
		{
			new String:name[32];
			GetClientName(target, name, sizeof(name));
			
			//remove hat if already hatted
			KillHat( target );
			
			SetHatModel(target, modelName);
			PerformHat(param1, target, 1);
			
			ShowActivity2(param1, "[SM] ", "Set hat \"%s\" on target '%s'", modelName, name);
		}
		
		/* Re-draw the menu if they're still valid */
		if (IsClientInGame(param1) && !IsClientInKickQueue(param1))
		{
			DisplayMenu_Hat_Player(param1);
		}
	}
}