/*****************************************************************


			G L O B A L   V A R S


*****************************************************************/
new String:g_modelfunKV[128];
new Handle:hKVModelFun = INVALID_HANDLE;


/*****************************************************************


			L I B R A R Y   I N C L U D E S


*****************************************************************/
#include "modelfun/lists/modellist.sp"
#include "modelfun/lists/particlelist.sp"


/*****************************************************************


			F O R W A R D   P U B L I C S


*****************************************************************/
OnPluginStart_Lists()
{
	//prepare kv custom messages file
	BuildPath(Path_SM, g_modelfunKV, 128, "data/modelfun.txt");
	
	hKVModelFun = CreateKeyValues("ModelFun");
	
	if(!FileToKeyValues(hKVModelFun, g_modelfunKV))
	{
		KeyValuesToFile(hKVModelFun, g_modelfunKV);
	}
	
	OnPluginStart_ModelList();
	
	if( ParticlesAllowed() )
		OnPluginStart_ParticleList();
}

OnPluginEnd_Lists()
{
	CloseHandle(hKVModelFun);
}


/*****************************************************************


			P L U G I N   F U N C T I O N S


*****************************************************************/
bool:AddModelsToMenu(Handle:menu, const String:listName[] )
{
	decl String:bufferKey[49];
	decl String:bufferValue[129];
	
	//get from kv file
	if(KvJumpToKey(hKVModelFun, listName))
	{
		if (!KvGotoFirstSubKey(hKVModelFun,false))
		{
			return false;
		}

		do
		{
			KvGetSectionName(hKVModelFun, bufferKey, sizeof(bufferKey));
			KvGetString( hKVModelFun, "", bufferValue, sizeof(bufferValue) );
			
			AddMenuItem(menu, bufferValue, bufferKey);
		} 
		while (KvGotoNextKey(hKVModelFun,false));		
	} 
	
	KvRewind(hKVModelFun);
	
	return true;
}

bool:PrintList( client, const String:listName[] )
{
	decl String:bufferKey[49];
	decl String:bufferValue[129];
	
	//get from kv file
	if(KvJumpToKey(hKVModelFun, listName))
	{
		if (!KvGotoFirstSubKey(hKVModelFun,false))
		{
			return false;
		}

		PrintToConsole( client, "-- Printing list: %s --", listName );
		
		do
		{
			KvGetSectionName(hKVModelFun, bufferKey, sizeof(bufferKey));
			KvGetString( hKVModelFun, "", bufferValue, sizeof(bufferValue) );
			
			PrintToConsole( client, "%s - %s", bufferKey, bufferValue );
			
		} 
		while (KvGotoNextKey(hKVModelFun,false));		
	} 
	
	KvRewind(hKVModelFun);
	
	return true;
}