/*****************************************************************


			G L O B A L   V A R S


*****************************************************************/
new String:g_particleListName[24];


/*****************************************************************


			F O R W A R D   P U B L I C S


*****************************************************************/
OnPluginStart_ParticleList()
{
	//detect particle list name
	if( g_GameType == GAME_TF2 )
	{
		g_particleListName = "particles_tf2";
		SetupDefaultParticleList_tf2();
	}
	else if( g_GameType == GAME_L4D )
	{
		g_particleListName = "particles_l4d";
		SetupDefaultParticleList_l4d();
	}
	else
	{
		SetFailState( "This game does not support particles, contact the plugin developer" );
	}	
	
	RegAdminCmd("sm_particlelist", Command_ParticleList, ADMFLAG_ROOT, "sm_particlelist - Print loaded modelfun particle list to console");
	RegAdminCmd("sm_refreshparticles", Command_RefreshParticles, ADMFLAG_ROOT, "sm_refreshparticles - Reloads modelfun particle list from 'addons/sourcemod/data/modelfun.txt'");
}




/****************************************************************


			C A L L B A C K   F U N C T I O N S


****************************************************************/
public Action:Command_ParticleList(client, args)
{
	if( !PrintList( client, g_particleListName ) )
	{
		PrintToConsole( client, "No Particles loaded!" );
	}
	
	return Plugin_Handled;	
}


public Action:Command_RefreshParticles(client, args)
{
	if(KvJumpToKey(hKVModelFun, g_particleListName))
	{
		KvDeleteThis( hKVModelFun );
		KvRewind(hKVModelFun);
		
		if(FileToKeyValues(hKVModelFun, g_modelfunKV))
		{
			ReplyToCommand(client, "[SM] Modelfun particle list reloaded!");

			KvRewind(hKVModelFun);
	
			return Plugin_Handled;
		}
	}
	
	ReplyToCommand(client, "[SM] Error reloading particle model list");
	KvRewind(hKVModelFun);
	
	return Plugin_Handled;	
}


/*****************************************************************


			P L U G I N   F U N C T I O N S


*****************************************************************/
SetupDefaultParticleList_l4d()
{
	//List from - http://developer.valvesoftware.com/wiki/List_of_L4D_Particles
	
	if(!KvJumpToKey(hKVModelFun, g_particleListName))
	{				
		KvJumpToKey(hKVModelFun, g_particleListName, true);
		KvSetString(hKVModelFun, "Awning Collapse", 	"awning_collapse");
		KvSetString(hKVModelFun, "Barricade Fire", 	"barricade_fire");
		KvSetString(hKVModelFun, "Boat Wake", 	"boat_wake");
		KvSetString(hKVModelFun, "Boat Wake Outro", 	"boat_wake_outro");
		KvSetString(hKVModelFun, "Bridge Collapse", 	"bridge_collapse");
		KvSetString(hKVModelFun, "Burning City Effect", 	"burning_city_effect");
		KvSetString(hKVModelFun, "Burning Wood", 	"burning_wood_02");
		KvSetString(hKVModelFun, "C130 Start", 	"C130_start");
		KvSetString(hKVModelFun, "Chopper Spotlight", 	"chopper_spotlight");
		KvSetString(hKVModelFun, "Cistern Drips", 	"cistern_drips");
		KvSetString(hKVModelFun, "Crows Flyaway", 	"crows_flyaway");
		KvSetString(hKVModelFun, "Drainpipe Short", 	"drainagepipe_short");
		KvSetString(hKVModelFun, "Fire Large", 	"env_fire_large");
		KvSetString(hKVModelFun, "Fire Large Smoke", 	"env_fire_large_smoke");
		KvSetString(hKVModelFun, "Fire Medium", 	"env_fire_medium");
		KvSetString(hKVModelFun, "Fire Barrel", 	"fire_barrel_big");
		KvSetString(hKVModelFun, "Pipe Fire", 	"fire_pipe");
		KvSetString(hKVModelFun, "Tanker Fire", 	"fire_tanker");
		KvSetString(hKVModelFun, "Window Fire", 	"fire_window");
		KvSetString(hKVModelFun, "Fireflies", 	"Fireflies");
		KvSetString(hKVModelFun, "Fireflies 2", 	"Fireflies_Cornfield");
		KvSetString(hKVModelFun, "Flies", 	"Flies");
		KvSetString(hKVModelFun, "Fog 1", 	"fog_lowpatch");
		KvSetString(hKVModelFun, "Fog 2", 	"fog_volume_1024_128");
		KvSetString(hKVModelFun, "Fog 3", 	"fog_volume_1024_512");
		KvSetString(hKVModelFun, "Gas Explosion Trails", 	"gas_explosion_debris_trails");
		KvSetString(hKVModelFun, "Gas Explosion 1", 	"gas_explosion_main");
		KvSetString(hKVModelFun, "Gas Explosion 2", 	"gas_explosion_pump");
		KvSetString(hKVModelFun, "Greenhouse Dust", 	"greenhouse_dust");
		KvSetString(hKVModelFun, "Leaves 1", 	"leaves");
		KvSetString(hKVModelFun, "Leaves 2", 	"leaves_blow_horizontal_1");
		KvSetString(hKVModelFun, "Molotov", 	"Molotov_groundfire");
		KvSetString(hKVModelFun, "Moths", 	"Moths");
		KvSetString(hKVModelFun, "Street Paper", 	"paper_streets");
		KvSetString(hKVModelFun, "Pipe Drips 1", 	"pipe_drips_h");
		KvSetString(hKVModelFun, "Pipe Drips 2", 	"pipe_drips_v");
		KvSetString(hKVModelFun, "Pillar Dust", 	"pillardust");
		KvSetString(hKVModelFun, "Cop Car Strobe 1", 	"policecar_tail_strobe");
		KvSetString(hKVModelFun, "Cop Car Strobe 2", 	"policecar_tail_strobe2");
		KvSetString(hKVModelFun, "Rain Intro", 	"rain_intro");
		KvSetString(hKVModelFun, "Rain Ripples 1", 	"rain_puddle_ripples");
		KvSetString(hKVModelFun, "Rain Ripples 2", 	"rain_puddle_ripples_large");
		KvSetString(hKVModelFun, "Rain Ripples 3", 	"rain_puddle_ripples_small");
		KvSetString(hKVModelFun, "Rain Sheet", 	"rain_sheet");
		KvSetString(hKVModelFun, "Rain Spot", 	"rain_spot");
		KvSetString(hKVModelFun, "Rain Stream 1", 	"rain_stream_01");				
		KvSetString(hKVModelFun, "Rain Stream 2", 	"rain_stream_02");
		KvSetString(hKVModelFun, "Rain Stream 3", 	"rain_stream_04");
		KvSetString(hKVModelFun, "Railroad Light 1", 	"railroad_light_blink1");
		KvSetString(hKVModelFun, "Railroad Light 2", 	"railroad_light_blink3");
		KvSetString(hKVModelFun, "Railroad Light 3", 	"railroad_light_blink2");
		KvSetString(hKVModelFun, "Railroad Light 4", 	"railroad_light_blink4");
		KvSetString(hKVModelFun, "Railroad Light Explode", 	"railroad_light_explode");
		KvSetString(hKVModelFun, "Railroad Light Glow", 	"railroad_light_glow");
		KvSetString(hKVModelFun, "Roaches 1", 	"roaches_few");
		KvSetString(hKVModelFun, "Roaches 2", 	"roaches_lot");
		KvSetString(hKVModelFun, "Roaches 3", 	"roaches_many");
		KvSetString(hKVModelFun, "Runway Lights", 	"runway_lights");
		KvSetString(hKVModelFun, "Sheetrock", 	"sheetrock");
		KvSetString(hKVModelFun, "Shore 1", 	"shore");
		KvSetString(hKVModelFun, "Shore 2", 	"shore_45");
		KvSetString(hKVModelFun, "Shore 3", 	"shore_75");
		KvSetString(hKVModelFun, "Shore 4", 	"shore_90");
		KvSetString(hKVModelFun, "Skyscraper Drips", 	"skyscraper_drips_h");
		KvSetString(hKVModelFun, "Campfire Smoke", 	"smoke_campfire");
		KvSetString(hKVModelFun, "Small Smoke", 	"smoke_small_black");
		KvSetString(hKVModelFun, "Window Smoke", 	"smoke_window");
		KvSetString(hKVModelFun, "Smokestack", 	"smokestack");
		KvSetString(hKVModelFun, "Stars", 	"stars_morning");
		KvSetString(hKVModelFun, "Steam Grate", 	"steam_grate");
		KvSetString(hKVModelFun, "Steam Long", 	"steam_long");
		KvSetString(hKVModelFun, "Manhole Steam", 	"steam_manhole");
		KvSetString(hKVModelFun, "Steam Short", 	"steam_short");
		KvSetString(hKVModelFun, "Subway Smoke", 	"subwaysmoke");
		KvSetString(hKVModelFun, "Sunrise", 	"sunrise");
		
		KvRewind(hKVModelFun);			
		KeyValuesToFile(hKVModelFun, g_modelfunKV);
		
		return true;		
	}
	else
	{
		KvRewind(hKVModelFun);		
		return false;
	}	
}


SetupDefaultParticleList_tf2()
{
	//List from - http://developer.valvesoftware.com/wiki/List_of_TF2_Particles
	
	if(!KvJumpToKey(hKVModelFun, g_particleListName))
	{				
		KvJumpToKey(hKVModelFun, g_particleListName, true);
		KvSetString(hKVModelFun, "Balloon 1", 	"bday_1balloon");
		KvSetString(hKVModelFun, "Balloon 2", 	"bday_balloon01");
		KvSetString(hKVModelFun, "Balloon 3", 	"bday_balloon02");
		KvSetString(hKVModelFun, "Confetti", 	"bday_confetti");
		KvSetString(hKVModelFun, "Building Explosion", 	"ExplosionCore_buildings");
		KvSetString(hKVModelFun, "Midair Explosion 1", 	"ExplosionCore_MidAir");
		KvSetString(hKVModelFun, "Midair Explosion 2", 	"ExplosionCore_MidAir_underwater");
		KvSetString(hKVModelFun, "Sapper Destroyed", 	"ExplosionCore_sapperdestroyed");
		KvSetString(hKVModelFun, "Explosion Core 1", 	"ExplosionCore_Wall");
		KvSetString(hKVModelFun, "Explosion Core 2", 	"ExplosionCore_Wall_underwater");
		KvSetString(hKVModelFun, "Critgun Blue", 	"critgun_weaponmodel_blu");
		KvSetString(hKVModelFun, "Critgun Red", 	"critgun_weaponmodel_red");
		KvSetString(hKVModelFun, "Health Blue", 	"healthgained_blu");
		KvSetString(hKVModelFun, "Health Red", 	"healthgained_red");
		KvSetString(hKVModelFun, "Eject Brass", 	"eject_minigunbrass");
		KvSetString(hKVModelFun, "Steam", 	"smoke_rocket_steam");
		KvSetString(hKVModelFun, "Steam Ship", 	"smoke_whitebillow_steamship_skybox");
		KvSetString(hKVModelFun, "Black Smoke", 	"smoke_wispy_black_granary");
		KvSetString(hKVModelFun, "Black Smoke 2", 	"smoke_blackbillow_dustbowl_skybox");
		KvSetString(hKVModelFun, "Black Smoke 3", 	"smoke_wispy_black_2fort");
		KvSetString(hKVModelFun, "Big Explosion", 	"cinefx_goldrush");
		KvSetString(hKVModelFun, "Rain", 	"env_rain_001");
		KvSetString(hKVModelFun, "Rain Ripples", 	"env_rain_ripples");
		KvSetString(hKVModelFun, "Rocket Trail", 	"rockettrail");
		KvSetString(hKVModelFun, "Crit Rocket Red", 	"critical_rocket_red");
		KvSetString(hKVModelFun, "Crit Rocket Red Sparks", 	"critical_rocket_redsparks");
		KvSetString(hKVModelFun, "Rocket Trail Underwater", 	"rockettrail_underwater");
		KvSetString(hKVModelFun, "Rocket Trial Bubbles", 	"rockettrail_waterbubbles");
		KvSetString(hKVModelFun, "Sentry Rocket", 	"sentry_rocket");
		KvSetString(hKVModelFun, "Sentry Rocket Burst", 	"sentry_rocket_burst");
		KvSetString(hKVModelFun, "Sentry Rocket Fire", 	"sentry_rocket_fire");
		KvSetString(hKVModelFun, "Tele Exit Red", 	"teleporter_red_exit");
		KvSetString(hKVModelFun, "Tele Glow Red", 	"teleporter_arms_circle_red");
		KvSetString(hKVModelFun, "Tele In Red", 	"teleporter_red_entrance");
		KvSetString(hKVModelFun, "Tele Charged Red", 	"teleporter_red_charged");
		KvSetString(hKVModelFun, "Tele Charged Red 2", 	"teleporter_red_charged_level2");
		KvSetString(hKVModelFun, "Tele Charged Red 3", 	"teleporter_red_charged_level3");
		KvSetString(hKVModelFun, "Tele In Red 2", 	"teleporter_red_entrance_level2");
		KvSetString(hKVModelFun, "Tele In Red 3", 	"teleporter_red_entrance_level3");
		KvSetString(hKVModelFun, "Tele Wisps Red", 	"teleporter_red_charged_wisps");
		KvSetString(hKVModelFun, "Tele Wisps Red 2", 	"teleporter_red_wisps_level2");

		KvRewind(hKVModelFun);			
		KeyValuesToFile(hKVModelFun, g_modelfunKV);
		
		return true;		
	}
	else
	{
		KvRewind(hKVModelFun);		
		return false;
	}	
}