/*****************************************************************


			G L O B A L   V A R S


*****************************************************************/
new g_PHatTarget[MAXPLAYERS+1];
new bool:g_PHatted[MAXPLAYERS+1] = {false, ...};
new String:g_PHatParticle[MAXPLAYERS+1][129];
new g_PHatEntity[MAXPLAYERS+1];


/*****************************************************************


			F O R W A R D   P U B L I C S


*****************************************************************/

OnPluginStart_PHat()
{
	RegAdminCmd("sm_phat", Command_ParticleHat, ADMFLAG_ROOT,"sm_phat <name or #userid> <particlename> [1|0] - toggles or sets player's particle hat status");
}

OnMapEnd_PHat()
{
	new maxclients = GetMaxClients();
	for (new i = 0; i <= maxclients; i++)
	{
		g_PHatted[i] = false;
	}
}

bool:OnClientConnect_PHat(client)
{
	KillParticleHat(client);
	return true;
}

bool:AskPluginLoad_PHat()
{
	CreateNative("ModelFun_PHatOff", Native_PHatOff);
	CreateNative("ModelFun_PerformPHat", Native_PerformPHat);
	
	return true;
}

/****************************************************************


			C A L L B A C K   F U N C T I O N S


****************************************************************/
Event_PlayerSpawn_PHat(Handle:event) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if( client && IsClientConnected(client) && !IsFakeClient(client) )
	{	
		if (g_PHatted[client] == true)
		{
			CreateParticleHat(client);
		}
	}
}

Event_PlayerDeath_PHat(Handle:event) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if ((IsClientInGame(client)) && g_PHatted[client] )
	{
		KillParticleHat(client);
		g_PHatted[client] = true;
	}
}


Event_PlayerDisc_PHat(Handle:event) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if( g_PHatted[client] )
	{
		KillParticleHat(client);
	}
}

public Action:Timer_Event_PlayerSpawn_PHat(Handle:timer, any:client) 
{
	if( client && IsClientConnected(client) && !IsFakeClient(client) )
	{	
		if (g_PHatted[client] == true)
		{
			CreateParticleHat(client);
		}
	}
	
	return Plugin_Handled;
}


public Action:Command_ParticleHat(client, args)
{
	decl String:particle[129];
	decl String:target[65];
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS];
	decl target_count;
	decl bool:tn_is_ml;
	new toggle = 2;
	
	if (args < 2 )
	{
		ReplyToCommand(client, "[SM] Usage: sm_phat <#userid|name> <particlename> [1|0]");
		return Plugin_Handled;
	}
		
	GetCmdArg(1, target, sizeof(target));	
	GetCmdArg(2, particle, sizeof(particle));
	if (args > 2)
	{
		decl String:arg3[2];
		GetCmdArg(3, arg3, sizeof(arg3));
		if (StrEqual(arg3[0],"1"))
		{
			toggle = 1;
		}
		else if (StrEqual(arg3[0],"0"))
		{
			toggle = 0;
		}
	}
	
	if ((target_count = ProcessTargetString(
			target,
			client,
			target_list,
			MAXPLAYERS,
			0,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}
	
	for (new i = 0; i < target_count; i++)
	{
		SetParticleHat(target_list[i], particle);
		PerformParticleHat(client, target_list[i], toggle);
	}
	
	ShowActivity2(client, "[SM] ", "Toggled particle hat \"%s\" on target '%s'", particle, target_name);
	
	return Plugin_Handled; 
}


/*****************************************************************


			N A T I V E   F U N C T I O N S


*****************************************************************/
public Native_PerformPHat(Handle:plugin, numParams)
{
	decl client;
	decl target;
	decl toggle;
	decl String:particle[129];
	new bool:hatnow= true;
	
	client = GetNativeCell(1);
	target = GetNativeCell(2);
	toggle = GetNativeCell(3);
	GetNativeString(4, particle, sizeof(particle));
	
	if( numParams > 5 )
	{
		hatnow = GetNativeCell(5);
	}

	SetParticleHat( target, particle );
	
	if( hatnow )
	{
		return PerformParticleHat( client, target, toggle );
	}
	
	return true;
}

public Native_PHatOff(Handle:plugin, numParams)
{
	decl client;
	decl target;
	
	client = GetNativeCell(1);
	target = GetNativeCell(2);
	
	PerformParticleHat( client, target, 0 );
}


/*****************************************************************


			P L U G I N   F U N C T I O N S


*****************************************************************/
SetParticleHat(target, String:particle[129])
{	
	g_PHatParticle[target] = particle;
}

bool:PerformParticleHat(client, target, toggle)
{
	switch (toggle)
	{
		case (2):
		{
			if (g_PHatted[target] == false)
			{
				CreateParticleHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" particled hatted with particle \"%s\"", client, target, g_PHatParticle[target]);
				return true;
			}
			else
			{
				KillParticleHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" normal", client, target);
				return false;
			}
		}

		case (1):
		{
			if (g_PHatted[target] == false)
			{
				CreateParticleHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" particle hatted with particle \"%s\"", client, target, g_PHatParticle[target]);
				return true;
			}			
		}
		
		case (0):
		{
			if (g_PHatted[target] == true)
			{
				KillParticleHat(target);
				LogAction(client, target, "\"%L\" made \"%L\" normal", client, target);
				return false;
			}				
		}
	}
	return false;
}


KillParticleHat(target)
{
	if (g_PHatted[target] == true)
	{
	    if (g_PHatEntity[target])
	    {
	    	g_PHatted[target] = false;
	    	    	
	        new String:classname[256];
	        GetEdictClassname(g_PHatEntity[target], classname, sizeof(classname));
	        
	        if (StrEqual(classname, "info_particle_system", false))
	        {
	            RemoveEdict(g_PHatEntity[target]);
	        }
	        
	        g_PHatEntity[target] = -1;
	    }
	}	
}


//Particle code stolen blatantly from stroniumdog's plugin Evil Admin: Trails (http://forums.alliedmods.net/showthread.php?t=79323)
CreateParticleHat(target)
{
	
	new Float:fPosition[3];
	GetClientEyePosition(target, fPosition);
	
	if( g_GameType == GAME_L4D2 )
	{
		fPosition[2] += 100;
		fPosition[1] -= 100;
	}
	else
	{
		fPosition[2] += 0;
		fPosition[1] -= 0;
	}

	new String:tName[128];
	new particle = CreateEntityByName("info_particle_system");
	
	if (IsValidEdict(particle))
	{
		g_PHatted[target] = true;
		
		TeleportEntity(particle, fPosition, NULL_VECTOR, NULL_VECTOR);
		
		Format(tName, sizeof(tName), "target%i", target);
		DispatchKeyValue(target, "targetname", tName);
		
		
		//DispatchKeyValue(particle, "targetname", "tf2particle")
		DispatchKeyValue(particle, "parentname", tName);
		DispatchKeyValue(particle, "effect_name", g_PHatParticle[target]);
		DispatchSpawn(particle);
		SetVariantString(tName);
		AcceptEntityInput(particle, "SetParent", particle, particle, 0);
		SetVariantString("flag");
		AcceptEntityInput(particle, "SetParentAttachment", particle, particle, 0);
		ActivateEntity(particle);
		AcceptEntityInput(particle, "start");
		
		g_PHatEntity[target] = particle;
		
	}	
}



/*****************************************************************


			A D M I N   M E N U   F U N C T I O N S


*****************************************************************/

SetupAdminMenu_PHat(TopMenuObject:parentmenu)
{
	AddToTopMenu(hTopMenu, 
		"sm_phat",
		TopMenuObject_Item,
		AdminMenu_PHat,
		parentmenu,
		"sm_phat",
		ADMFLAG_ROOT);
}

public AdminMenu_PHat(Handle:topmenu, 
					  TopMenuAction:action,
					  TopMenuObject:object_id,
					  param,
					  String:buffer[],
					  maxlength)
{
	if (action == TopMenuAction_DisplayOption)
	{
		Format(buffer, maxlength, "%s", "Particle Hat player");
	}
	else if (action == TopMenuAction_SelectOption)
	{
		DisplayMenu_PHat_Player(param);
	}
}

DisplayMenu_PHat_Player(client)
{
	new Handle:menu = CreateMenu(MenuHandler_PHat_Player);
	
	decl String:title[100];
	Format(title, sizeof(title), "%s:", "Particle Hat player");
	SetMenuTitle(menu, title);
	SetMenuExitBackButton(menu, true);
	
	AddTargetsToMenu(menu, client, true, false);
	
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_PHat_Player(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];
		new userid, target;
		
		GetMenuItem(menu, param2, info, sizeof(info));
		userid = StringToInt(info);

		if ((target = GetClientOfUserId(userid)) == 0)
		{
			PrintToChat(param1, "[SM] %t", "Player no longer available");
		}
		else if (!CanUserTarget(param1, target))
		{
			PrintToChat(param1, "[SM] %t", "Unable to target");
		}
		else
		{
			g_PHatTarget[param1] = userid;
			DisplayMenu_Hat_Particle(param1);
			return;	// Return, because we went to a new menu and don't want the re-draw to occur.
		}
		
		/* Re-draw the menu if they're still valid */
		if (IsClientInGame(param1) && !IsClientInKickQueue(param1))
		{
			DisplayMenu_PHat_Player(param1);
		}
	}
	
	return;
}

DisplayMenu_Hat_Particle(client)
{
	new Handle:menu = CreateMenu(MenuHandler_Hat_Particle);
	
	decl String:title[100];
	Format(title, sizeof(title), "%s:", "Set Hat Particle");
	SetMenuTitle(menu, title);
	SetMenuExitBackButton(menu, true);
	
	AddModelsToMenu(menu, g_particleListName);
	
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}


public MenuHandler_Hat_Particle(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		new target;
		decl String:modelName[129];
		
		GetMenuItem(menu, param2, modelName, sizeof(modelName));
		
		if ((target = GetClientOfUserId(g_PHatTarget[param1])) == 0)
		{
			PrintToChat(param1, "[SM] %t", "Player no longer available");
		}
		else if (!CanUserTarget(param1, target))
		{
			PrintToChat(param1, "[SM] %t", "Unable to target");
		}
		else
		{
			new String:name[32];
			GetClientName(target, name, sizeof(name));
			
			//remove hat if already hatted
			KillParticleHat( target );
			
			SetParticleHat(target, modelName);
			PerformParticleHat(param1, target, 1);
			
			ShowActivity2(param1, "[SM] ", "Set hat \"%s\" on target '%s'", modelName, name);
		}
		
		/* Re-draw the menu if they're still valid */
		if (IsClientInGame(param1) && !IsClientInKickQueue(param1))
		{
			DisplayMenu_PHat_Player(param1);
		}
	}
}